;(function(){

    $$ = Toolbox;

    // newpostPrompt ...
    var newpostPrompt = $("[newpost-wrapper]").html()

    // handleNewpostPrompt_Click ...
    var handleNewpostPrompt_Click = function(e) {
        $("[newpost-wrapper]").load("/api/v1/admin/newpost", function (e) {
            setTimeout(function() {
                $("[newpost]").focus();
            }, 0);
        });
    };
    $(document).on("click", "[newpost-wrapper] span", handleNewpostPrompt_Click);

    // handleCloseButton_Click ...
    var handleCloseButton_Click = function(e, fn) {
        $("[newpost-wrapper]").html(newpostPrompt);
        fn();
    };
    $(document).on("click", "[tb-cancel]", handleCloseButton_Click);

    // handleUploadPhoto_Click ...
    var handleUploadPhoto_Click = function(e) {
        if ($("[preview").length == 0) {
            setTimeout(function() {
                $("[newpost-wrapper] span").click();
                handleUploadPhoto_Click ({}); 
            }, 300);
        } else {
            $("#files").click(); //trigger("click");
        }
    };
    $(document).on("click", "[tb-photo]", handleUploadPhoto_Click);

    // helperEnableDisableSubmit ...
    var helperEnableDisableSubmit = function(el) {
        if ($(el).html().length > 0) {
            $("[newpost-submit]")
                .removeClass("pill-disabled")
                .prop("disabled", false)
            ;
        } else {
            $("[newpost-submit]")
                .addClass("pill-disabled")
                .prop("disabled", true)
            ;
        }
    };

    // handleNewpost_Input ...
    var handleNewpost_Input = function(e) {
        helperEnableDisableSubmit($(this));
    };
    $(document).on("input", "[newpost]", handleNewpost_Input);

    // handlePreview_Input  ...
    var handlePreview_Input = function(e) {
        helperEnableDisableSubmit($(this));
    };
    $(document).on("input", "[preview]", handlePreview_Input);


    var handleFileSelect_Change = function (e) {

        // Check for the various File API support.
        if (window.File && window.FileReader && window.FileList && window.Blob) {
            // Great success! All the File APIs are supported.
        } else {
            alert('The File APIs are not fully supported in this browser.');
            return;
        }

        var files = e.target.files; // FileList object

        // Loop through the FileList and render image files as thumbnails.
        for (var i = 0, f; f = files[i]; i++) {

            // Only process image files.
            if (f.type.match('image.*') == false) {
                continue;
            }

            var reader = new FileReader();

            var el = $("<div class='three-quarters-loader'>");
            $("[preview]")
                .append(el)
                .show()
            ;

            // Closure to capture the file information.
            reader.onload = (function (theFile, el) {

                return function (e) {
                    var url = '/api/v1/utils/resizephoto';
                    var xhr = new XMLHttpRequest();
                    var fd = new FormData();
                    xhr.open("POST", url, true);
                    xhr.setDoOutput = true;
                    xhr.setDoInput = true;
                    xhr.setUseCaches = false;
                    xhr.onreadystatechange = function () {
                        if (xhr.readyState == 4 && xhr.status == 200) {
                            // Every thing ok, file uploaded
                            // console.log(xhr.responseText); // handle response.
                            var data = new String(xhr.responseText);
                            photo = JSON.parse(data);
                            if (photo.thumbnail_file.length > 0) {
                                var img = $("<img>");
                                $(img).attr("src", photo.thumbnail_file); 
                                $(img).attr("fullsize", photo.resized_file); 
                                $(img).attr("mimetype", theFile.type); 
                                $(el)
                                   .html(img)
                                   .removeClass("three-quarters-loader")
                                   .addClass("image")
                                   .trigger("input")
                                ;
                            }
                        }
                    };
                    xhr.onerror = function() {
                        alert(xhr.responseText)
                    };
                    fd.append("file", theFile);
                    xhr.send(fd);

                };
            })(f, el);

            // Read in the image file as a data URL.
            reader.readAsDataURL(f);
        }
    };
    $(document).on("change", "#files", handleFileSelect_Change);

    var handlePost_Click = function(e) {

        var data = {
             "title": $("[newpost-title] input[type=text]").val()
            ,"content": $("[newpost]").html()
            ,"meta": new Array()
        };

        $("[preview] .image img").each(function(idx) {
            data["meta"].push({
                "metatype":"imageset", 
                "contenttype":$(this).attr("mimetype"), 
                "content":$(this).attr("fullsize"), 
                "preview":$(this).attr("src"), 
                "sequence": idx
            });
        });

        $$.Create (
             "/api/v1/admin/post"
            ,JSON.stringify(data)
            ,function(e){ 
                handleCloseButton_Click({}, function() {
                    $(window).trigger("loadpagecontent", ["true"]);
                });
             }
            ,function(e){ 
                var err = JSON.parse(e.responseText);
                alert("error: " + err.message);
             }
        );

    };
    $(document).on("click", "[newpost-submit]", handlePost_Click);

    var handlePostEdit_Click = function(e) {
        var id = $(this).attr("data-postid");
        $("[newpost-wrapper]").load("/api/v1/admin/newpost/"+id, function (e) {
            setTimeout(function() {
                var post = $("[newpost-wrapper]").find("[newpost]").text();
                $("[newpost]")
                    .html(post)
                    .focus()
                    ;
            }, 0);
        });

    };
    $(document).on("click", ".post-edit", handlePostEdit_Click);

    var handleToolbarFormat_Click = function(e) {
        res = document.execCommand($(this).attr("tb-format"), false, "");
    };
    $(document).on("click", "[tb-format]", handleToolbarFormat_Click);

    var preventDefault = function(e) {
        e.preventDefault();
        return setTimeout(300);
    };
    $(document).on("mousedown", "[tb-format]", preventDefault);

    //handleNewpostPrompt_Click ({});

}).call(this);
